'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _NextGlobalClientStore = require('../modules/NextGlobalClientStore');

var _NextGlobalClientStore2 = _interopRequireDefault(_NextGlobalClientStore);

var _demandEnvVar = require('../modules/demandEnvVar');

var _demandEnvVar2 = _interopRequireDefault(_demandEnvVar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loadEnvironmentVars = function loadEnvironmentVars(namesToAliases) {
  var environment = {};
  (0, _keys2.default)(namesToAliases).forEach(function (key) {
    var value = (0, _demandEnvVar2.default)(key);
    var alias = namesToAliases[key];
    environment[alias] = value;
  });

  return environment;
};

var InjectEnvVars = function InjectEnvVars(namesToAliases) {
  return function (Page) {
    return function (_Component) {
      (0, _inherits3.default)(InjectEnvVarsWrapper, _Component);
      (0, _createClass3.default)(InjectEnvVarsWrapper, null, [{
        key: 'getInitialProps',
        value: function () {
          var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(pageContext) {
            var env, pageProps;
            return _regenerator2.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    env = process.browser ? _NextGlobalClientStore2.default.get('env') : loadEnvironmentVars(namesToAliases);

                    if (!Page.getInitialProps) {
                      _context.next = 7;
                      break;
                    }

                    _context.next = 4;
                    return Page.getInitialProps((0, _extends3.default)({}, pageContext, { env: env }));

                  case 4:
                    _context.t0 = _context.sent;
                    _context.next = 8;
                    break;

                  case 7:
                    _context.t0 = {};

                  case 8:
                    pageProps = _context.t0;
                    return _context.abrupt('return', (0, _extends3.default)({}, pageProps, { env: env }));

                  case 10:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function getInitialProps(_x) {
            return _ref.apply(this, arguments);
          }

          return getInitialProps;
        }()
      }]);

      function InjectEnvVarsWrapper(props) {
        (0, _classCallCheck3.default)(this, InjectEnvVarsWrapper);

        var _this = (0, _possibleConstructorReturn3.default)(this, (InjectEnvVarsWrapper.__proto__ || (0, _getPrototypeOf2.default)(InjectEnvVarsWrapper)).call(this, props));

        if (process.browser) {
          _NextGlobalClientStore2.default.set('env', props.env);
        }
        return _this;
      }

      (0, _createClass3.default)(InjectEnvVarsWrapper, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Page, this.props);
        }
      }]);
      return InjectEnvVarsWrapper;
    }(_react.Component);
  };
};

exports.default = InjectEnvVars;