'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _NextGlobalClientStore = require('../modules/NextGlobalClientStore');

var _NextGlobalClientStore2 = _interopRequireDefault(_NextGlobalClientStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getGithubAccessToken = function getGithubAccessToken(req) {
  if (process.browser) {
    return _NextGlobalClientStore2.default.get('githubAccessToken');
  } else {
    var accessTokenCookie = req.headers.cookie && req.headers.cookie.split(';').map(function (c) {
      return c.trim();
    }).find(function (c) {
      return c.startsWith('githubAccessToken=');
    });

    if (accessTokenCookie) {
      return accessTokenCookie.split('=').pop();
    }
  }
};

var InjectGithubAccessToken = function InjectGithubAccessToken(Page) {
  return function (_Component) {
    (0, _inherits3.default)(InjectGithubAccessTokenWrapper, _Component);
    (0, _createClass3.default)(InjectGithubAccessTokenWrapper, null, [{
      key: 'getInitialProps',
      value: function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(pageContext) {
          var req, githubAccessToken, pageProps;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  req = pageContext.req;
                  githubAccessToken = getGithubAccessToken(req);

                  if (!Page.getInitialProps) {
                    _context.next = 8;
                    break;
                  }

                  _context.next = 5;
                  return Page.getInitialProps((0, _extends3.default)({}, pageContext, { githubAccessToken: githubAccessToken }));

                case 5:
                  _context.t0 = _context.sent;
                  _context.next = 9;
                  break;

                case 8:
                  _context.t0 = {};

                case 9:
                  pageProps = _context.t0;
                  return _context.abrupt('return', (0, _extends3.default)({}, pageProps, { githubAccessToken: githubAccessToken }));

                case 11:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function getInitialProps(_x) {
          return _ref.apply(this, arguments);
        }

        return getInitialProps;
      }()
    }]);

    function InjectGithubAccessTokenWrapper(props) {
      (0, _classCallCheck3.default)(this, InjectGithubAccessTokenWrapper);

      var _this = (0, _possibleConstructorReturn3.default)(this, (InjectGithubAccessTokenWrapper.__proto__ || (0, _getPrototypeOf2.default)(InjectGithubAccessTokenWrapper)).call(this, props));

      if (process.browser) {
        _NextGlobalClientStore2.default.set('githubAccessToken', props.githubAccessToken);
      }
      return _this;
    }

    (0, _createClass3.default)(InjectGithubAccessTokenWrapper, [{
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Page, this.props);
      }
    }]);
    return InjectGithubAccessTokenWrapper;
  }(_react.Component);
};

exports.default = InjectGithubAccessToken;