'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _NextGlobalClientStore = require('../modules/NextGlobalClientStore');

var _NextGlobalClientStore2 = _interopRequireDefault(_NextGlobalClientStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getGithubUser = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(githubAccessToken) {
    var url, headers, options, result;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (githubAccessToken) {
              _context.next = 2;
              break;
            }

            return _context.abrupt('return');

          case 2:
            if (!process.browser) {
              _context.next = 4;
              break;
            }

            return _context.abrupt('return', _NextGlobalClientStore2.default.get('githubUser'));

          case 4:
            url = 'https://api.github.com/user';
            headers = { Authorization: 'token ' + githubAccessToken };
            options = { headers: headers };
            result = void 0;
            _context.prev = 8;
            _context.next = 11;
            return _axios2.default.get(url, options);

          case 11:
            result = _context.sent;
            _context.next = 18;
            break;

          case 14:
            _context.prev = 14;
            _context.t0 = _context['catch'](8);

            if (!(_context.t0.response.status !== 401)) {
              _context.next = 18;
              break;
            }

            throw _context.t0;

          case 18:
            if (!result) {
              _context.next = 20;
              break;
            }

            return _context.abrupt('return', result.data);

          case 20:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[8, 14]]);
  }));

  return function getGithubUser(_x) {
    return _ref.apply(this, arguments);
  };
}();

var InjectGithubUser = function InjectGithubUser(Page) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    (0, _inherits3.default)(InjectGithubUserWrapper, _Component);
    (0, _createClass3.default)(InjectGithubUserWrapper, null, [{
      key: 'getInitialProps',
      value: function () {
        var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(pageContext) {
          var githubAccessToken, githubUser, pageProps;
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  githubAccessToken = pageContext.githubAccessToken;
                  _context2.next = 3;
                  return getGithubUser(githubAccessToken);

                case 3:
                  githubUser = _context2.sent;

                  if (!Page.getInitialProps) {
                    _context2.next = 10;
                    break;
                  }

                  _context2.next = 7;
                  return Page.getInitialProps((0, _extends3.default)({}, pageContext, { githubUser: githubUser }));

                case 7:
                  _context2.t0 = _context2.sent;
                  _context2.next = 11;
                  break;

                case 10:
                  _context2.t0 = {};

                case 11:
                  pageProps = _context2.t0;
                  return _context2.abrupt('return', (0, _extends3.default)({}, pageProps, { githubUser: githubUser }));

                case 13:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function getInitialProps(_x2) {
          return _ref2.apply(this, arguments);
        }

        return getInitialProps;
      }()
    }]);

    function InjectGithubUserWrapper(props) {
      (0, _classCallCheck3.default)(this, InjectGithubUserWrapper);

      var _this = (0, _possibleConstructorReturn3.default)(this, (InjectGithubUserWrapper.__proto__ || (0, _getPrototypeOf2.default)(InjectGithubUserWrapper)).call(this, props));

      _this.state = {
        githubUser: props.githubUser
      };

      if (process.browser) {
        _NextGlobalClientStore2.default.set('githubUser', props.githubUser);
      }
      return _this;
    }

    (0, _createClass3.default)(InjectGithubUserWrapper, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        var _this2 = this;

        if (process.browser) {
          var githubUser = this.props.githubUser;

          var serializedUser = githubUser ? (0, _stringify2.default)(githubUser) : null;
          window.localStorage.setItem('githubUser', serializedUser);
          window.onstorage = function (_ref3) {
            var key = _ref3.key,
                _ref3$newValue = _ref3.newValue,
                newValue = _ref3$newValue === undefined ? null : _ref3$newValue;

            if (key === 'githubUser') {
              _this2.setState({
                githubUser: newValue ? JSON.parse(newValue) : null
              });
            }
          };
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {}
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Page, (0, _extends3.default)({}, this.props, { githubUser: this.state.githubUser }));
      }
    }]);
    return InjectGithubUserWrapper;
  }(_react.Component), _class.propTypes = {
    githubUser: _react.PropTypes.shape({
      login: _react.PropTypes.string.isRequired
    })
  }, _temp;
};

exports.default = InjectGithubUser;